--所有需要供按键精灵使用的插件函数，都必须加 QMPlugin. 前缀
--在按键精灵中采用 Import "插件名.lua" 导入插件后，再用 插件名.函数名 即可调用

local function print(...)
	LuaAuxLib.TracePrint(':', ...)
end

local sh = {}
QMPlugin = sh


function sh.Read(FileName)
	local iRet, sRet = pcall(function()
		local f = io.open(FileName, 'r')
        local ret
        if f then
            ret = f:read('*all')
            f:close()
            return ret
        end
        return null
	end)
	if iRet == true then
		return sRet
	else
		print(sRet)
		return ""
	end
end

function sh.ReadLines(FileName)
	local iRet, sRet = pcall(function()
		local f = io.open(FileName, 'r')
        local tRet = {}
        local sRet = ''
        if f then
            while sRet do
                sRet = f:read("*line")
                if sRet then
                    sRet = string.gsub(sRet, '[\r\n]', '')
                    table.insert(tRet, sRet)
                end
            end
            f:close()
            return tRet
        end
        return ""--null
	end)
	if iRet == true then
		return sRet
	else
		print(sRet)
		return ""
	end
end

function sh.ReadLine(FileName, LineNum)
	local iRet, sRet = pcall(function()
		local tLines = sh.ReadLines(FileName)
        if LineNum == 0 then LineNum = 1 end -- 容错
        if tLines and LineNum <= #tLines then
            return tLines[LineNum]
        end
        return ""--null
	end)
	if iRet == true then
		return sRet
	else
		print(sRet)
		return ""
	end
end


function sh.LinesNumber(FileName)
	local iRet, sRet = pcall(function()
		local tLines = sh.ReadLines(FileName)
        if tLines then
            return #tLines
        end
        return 0
	end)
	if iRet == true then
		return sRet
	else
		print(sRet)
		return ""
	end
end


function sh.Write(FileName, ...)
	local arg={...}
	local iRet, sRet = pcall(function()
		local f = io.open(FileName, "w")
        if f then
            f:write(table.concat(arg))
            f:close()
        end
	end)
	if iRet == true then
		return sRet
	else
		print(sRet)
		return ""
	end
end

function sh.WriteLine(FileName, LineNum, Content)
	local iRet, sRet = pcall(function()
		local tLines = sh.ReadLines(FileName)
        if tLines and LineNum <= #tLines then
            -- tLines[LineNum] = Content
            table.insert(tLines, LineNum, Content)
            sh.WriteLines(FileName, tLines)
        end
	end)
	if iRet == true then
		return sRet
	else
		print(sRet)
		return ""
	end
end 

function sh.WriteLines(FileName, Lines)
	local iRet, sRet = pcall(function()
		local f = io.open(FileName, "w+")
        if f then
            for index, value in ipairs(Lines) do
                f:write(value .. '\n')
            end
            f:close()
        end
	end)
	if iRet == true then
		return sRet
	else
		print(sRet)
		return ""
	end
end

function sh.Append(FileName, ...)
	local arg={...}
	local iRet, sRet = pcall(function()
		local f = io.open(FileName, "a+")
        if f then
            f:write(table.concat(arg))
            f:close()
        end
	end)
	if iRet == true then
		return sRet
	else
		print(sRet)
		return ""
	end
end

function sh.DeleteLine(FileName, LineNum)
	local iRet, sRet = pcall(function()
		local tLines = sh.ReadLines(FileName)
        if LineNum > #tLines then LineNum = #tLines end
        if tLines and LineNum <= #tLines then
            table.remove(tLines, LineNum)
            sh.WriteLines(FileName, tLines)
        end
	end)
	if iRet == true then
		return sRet
	else
		print(sRet)
		return ""
	end
end

function sh.Bytes(FileName)
    local iRet, sRet = pcall(function()
		local size = 0
        local f = io.open(FileName, "rb")
		if f then
		    size = f:seek("end")
		    f:close()
		end
        return size
	end)
	if iRet == true then
		return sRet
	else
		print(sRet)
		return ""
	end
end

function sh.Length(FileName)
    local iRet, sRet = pcall(function()
        local fileLength = 0
        local strContent = sh.Read(FileName)
        strContent = string.gsub(strContent, '[\r\n]', '')
        
        --计算strContent中UTF8格式的字符个数
        local len = #strContent
        local left = len
        local cnt = 0
        local arr={0,0xc0,0xe0,0xf0,0xf8,0xfc}
        while left ~= 0 do
            local tmp=string.byte(strContent,-left)
            local i=#arr
            while arr[i] do
                if tmp>=arr[i] then 
                    left=left-i
                    break
                end
                i=i-1
            end
            cnt=cnt+1
        end
        fileLength = cnt
        return fileLength
	end)
	if iRet == true then
		return sRet
	else
		print(sRet)
		return ""
	end
end